package helper;

import base.DemoVo;
import com.yanzuoguang.util.exception.CodeException;
import com.yanzuoguang.util.helper.TypeHelper;
import com.yanzuoguang.util.vo.ResponseResult;
import helper.vo.ResponseDataMainResult;
import org.junit.Test;

import java.lang.reflect.Method;
import java.util.List;

public class TestTypeHelper {

    public ResponseDataMainResult<List<DemoVo>, DemoVo> getReturnType() {
        return null;
    }

    @Test
    public void test() throws NoSuchMethodException {
        // 获取泛型的返回值类型
        Method method = TestTypeHelper.class.getMethod("getReturnType");
        Class<?> returnType = method.getReturnType();
        TypeHelper.printSuperClass(returnType);
        boolean isSub = TypeHelper.isSubType(returnType, ResponseResult.class);
        if (!isSub) {
            throw new CodeException("泛型继承检测错误");
        }
    }
}
