package helper.vo;

import com.yanzuoguang.util.vo.ResponseResult;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 评论结果查看结果
 *
 * @author 颜佐光
 */
@ApiModel(description = "评论结果查看结果")
public class ResponseDataMainResult<T extends Object, M extends Object> extends ResponseResult<T> {

    /**
     * 主表数据,在状态成功时有效
     */
    @ApiModelProperty(
            value = "主表数据",
            notes = "主表数据,在状态成功时有效",
            required = true
    )
    private M main;

    public M getMain() {
        return main;
    }

    public void setMain(M main) {
        this.main = main;
    }
}
